diff --git a/sys/platform/vkernel64/x86_64/mp.c b/sys/platform/vkernel64/x86_64/mp.c
index c5a38c1cf22..c571c2abec6 100644
--- a/sys/platform/vkernel64/x86_64/mp.c
+++ b/sys/platform/vkernel64/x86_64/mp.c
@@ -39,7 +39,6 @@
 #include <sys/memrange.h>
 #include <sys/tls.h>
 #include <sys/types.h>
-#include <sys/vmm.h>
 
 #include <vm/vm_extern.h>
 #include <vm/vm_kern.h>
@@ -65,8 +64,6 @@
 
 extern pt_entry_t *KPTphys;
 
-extern int vmm_enabled;
-
 volatile cpumask_t stopped_cpus;
 /* which cpus are ready for IPIs etc? */
 cpumask_t	smp_active_mask = CPUMASK_INITIALIZER_ONLYONE;
@@ -393,7 +390,6 @@ start_all_aps(u_int boot_addr)
 	struct privatespace *ps;
 	vm_page_t m;
 	vm_offset_t va;
-	void *stack;
 	pthread_attr_t attr;
 	size_t ipiq_size;
 #if 0
@@ -465,16 +461,6 @@ start_all_aps(u_int boot_addr)
 		 */
 		cpu_disable_intr();
 
-		if (vmm_enabled) {
-			stack = mmap(NULL, KERNEL_STACK_SIZE,
-				     PROT_READ|PROT_WRITE|PROT_EXEC,
-				     MAP_ANON, -1, 0);
-			if (stack == MAP_FAILED) {
-				panic("Unable to allocate stack for thread %d\n", x);
-			}
-			pthread_attr_setstack(&attr, stack, KERNEL_STACK_SIZE);
-		}
-
 		pthread_create(&ap_tids[x], &attr, start_ap, NULL);
 		cpu_enable_intr();
 
diff --git a/sys/platform/vkernel64/x86_64/trap.c b/sys/platform/vkernel64/x86_64/trap.c
index 9b7da3a193d..cc3b2fb112e 100644
--- a/sys/platform/vkernel64/x86_64/trap.c
+++ b/sys/platform/vkernel64/x86_64/trap.c
@@ -95,7 +95,6 @@ int (*pmath_emulate) (struct trapframe *);
 static int trap_pfault (struct trapframe *, int, vm_offset_t);
 static void trap_fatal (struct trapframe *, int, vm_offset_t);
 void dblfault_handler (void);
-extern int vmm_enabled;
 
 static struct krate segfltrate = { 1 };
 
@@ -1401,10 +1400,7 @@ go_user(struct intrframe *frame)
 		 * Set PGEX_U unconditionally, indicating a user frame (the
 		 * bit is normally set only by T_PAGEFLT).
 		 */
-		if (vmm_enabled)
-			id = (void *)vtophys(curproc->p_vmspace->vm_pmap.pm_pml4);
-		else
-			id = &curproc->p_vmspace->vm_pmap;
+		id = &curproc->p_vmspace->vm_pmap;
 
 		/*
 		 * The GDF_VIRTUSER hack helps statclock() figure out who
diff --git a/sys/sys/param.h b/sys/sys/param.h
index 648788a89dd..f26229113d2 100644
--- a/sys/sys/param.h
+++ b/sys/sys/param.h
@@ -231,9 +231,10 @@
  * 600101 - kernel_{map,pmap,object} and {buffer,clean,pager}_map globals
  *          become pointers
  * 600102 - add nvmm(4) and libnvmm(3)
+ * 600103 - removal of the old vmm code
  */
 #undef __DragonFly_version
-#define __DragonFly_version 600102	/* propagated to newvers */
+#define __DragonFly_version 600103	/* propagated to newvers */
 
 #include <sys/_null.h>
 
diff --git a/sys/sys/proc.h b/sys/sys/proc.h
index 2291f8a13f5..56a7519d6ce 100644
--- a/sys/sys/proc.h
+++ b/sys/sys/proc.h
@@ -306,9 +306,9 @@ struct	proc {
 	u_short		p_depth;	/* Used to downscale resource limits */
 
 	int		p_ionice;
-	void		*p_unused02;
+	void		*p_unused01;
 /* End area that is copied on creation. */
-#define	p_endcopy	p_unused02
+#define	p_endcopy	p_unused01
 	u_short		p_acflag;	/* Accounting flags. */
 
 	int		p_lock;		/* Prevent proc destruction */
@@ -330,9 +330,7 @@ struct	proc {
 	struct lwkt_token p_token;	/* Token for LWP access to proc */
 	struct sem_undo	*p_sem_undo;	/* Fast semaphore tracking lookup */
 	void		*p_drv_priv;	/* scp linkage (for syscons) */
-	void		*p_vmm;
-	cpulock_t	p_vmm_cpulock;	/* count cpus in and kickout lock */
-	cpumask_t	p_vmm_cpumask;	/* cpus entering or in vmm */
+	char		p_unused02[44];
 	struct sys_upmap *p_upmap;	/* user RW mappable per-process page */
 	forkid_t	p_forkid;	/* unique forkid */
 	struct sysreaper *p_reaper;	/* reaper control */
diff --git a/sys/sys/syscall.h b/sys/sys/syscall.h
index 25851565f3e..58343c514c4 100644
--- a/sys/sys/syscall.h
+++ b/sys/sys/syscall.h
@@ -369,8 +369,8 @@
 #define	SYS_linkat	531
 #define	SYS_eaccess	532
 #define	SYS_lpathconf	533
-#define	SYS_vmm_guest_ctl	534
-#define	SYS_vmm_guest_sync_addr	535
+				/* 534 is obsolete vmm_guest_ctl */
+				/* 535 is obsolete vmm_guest_sync_addr */
 #define	SYS_procctl	536
 #define	SYS_chflagsat	537
 #define	SYS_pipe2	538
diff --git a/sys/sys/syscall.mk b/sys/sys/syscall.mk
index fb4ed95c666..fa64d039e99 100644
--- a/sys/sys/syscall.mk
+++ b/sys/sys/syscall.mk
@@ -297,8 +297,6 @@ MIASM =  \
 	linkat.o \
 	eaccess.o \
 	lpathconf.o \
-	vmm_guest_ctl.o \
-	vmm_guest_sync_addr.o \
 	procctl.o \
 	chflagsat.o \
 	pipe2.o \
diff --git a/sys/sys/sysproto.h b/sys/sys/sysproto.h
index 6d97609fb94..0d0058dfbc8 100644
--- a/sys/sys/sysproto.h
+++ b/sys/sys/sysproto.h
@@ -1343,14 +1343,6 @@ struct	lpathconf_args {
 	char *	path;	char path_[PAD_(char *)];
 	int	name;	char name_[PAD_(int)];
 };
-struct	vmm_guest_ctl_args {
-	int	op;	char op_[PAD_(int)];
-	struct vmm_guest_options *	options;	char options_[PAD_(struct vmm_guest_options *)];
-};
-struct	vmm_guest_sync_addr_args {
-	long *	dstaddr;	char dstaddr_[PAD_(long *)];
-	long *	srcaddr;	char srcaddr_[PAD_(long *)];
-};
 struct	procctl_args {
 	idtype_t	idtype;	char idtype_[PAD_(idtype_t)];
 	id_t	id;	char id_[PAD_(id_t)];
@@ -1747,8 +1739,6 @@ int	sys_vquotactl (struct sysmsg *sysmsg, const struct vquotactl_args *);
 int	sys_linkat (struct sysmsg *sysmsg, const struct linkat_args *);
 int	sys_eaccess (struct sysmsg *sysmsg, const struct eaccess_args *);
 int	sys_lpathconf (struct sysmsg *sysmsg, const struct lpathconf_args *);
-int	sys_vmm_guest_ctl (struct sysmsg *sysmsg, const struct vmm_guest_ctl_args *);
-int	sys_vmm_guest_sync_addr (struct sysmsg *sysmsg, const struct vmm_guest_sync_addr_args *);
 int	sys_procctl (struct sysmsg *sysmsg, const struct procctl_args *);
 int	sys_chflagsat (struct sysmsg *sysmsg, const struct chflagsat_args *);
 int	sys_pipe2 (struct sysmsg *sysmsg, const struct pipe2_args *);
diff --git a/sys/sys/sysunion.h b/sys/sys/sysunion.h
index 55c15d9d64d..37c67f21973 100644
--- a/sys/sys/sysunion.h
+++ b/sys/sys/sysunion.h
@@ -303,8 +303,6 @@ union sysunion {
 	struct	linkat_args linkat;
 	struct	eaccess_args eaccess;
 	struct	lpathconf_args lpathconf;
-	struct	vmm_guest_ctl_args vmm_guest_ctl;
-	struct	vmm_guest_sync_addr_args vmm_guest_sync_addr;
 	struct	procctl_args procctl;
 	struct	chflagsat_args chflagsat;
 	struct	pipe2_args pipe2;
diff --git a/sys/sys/thread.h b/sys/sys/thread.h
index db32ce4305d..01bfdd8bb51 100644
--- a/sys/sys/thread.h
+++ b/sys/sys/thread.h
@@ -292,7 +292,7 @@ struct thread {
     char	td_comm[MAXCOMLEN+1]; /* typ 16+1 bytes */
     struct thread *td_preempted; /* we preempted this thread */
     struct ucred *td_ucred;	/* synchronized from proc->p_ucred */
-    void	 *td_vmm;	/* vmm private data */
+    void	*td_unused04;
     lwkt_tokref_t td_toks_have;		/* tokens we own */
     lwkt_tokref_t td_toks_stop;		/* tokens we want */
     struct lwkt_tokref td_toks_array[LWKT_MAXTOKENS];
diff --git a/sys/vfs/procfs/procfs_mem.c b/sys/vfs/procfs/procfs_mem.c
index 1a168741438..6ffc1d78017 100644
--- a/sys/vfs/procfs/procfs_mem.c
+++ b/sys/vfs/procfs/procfs_mem.c
@@ -59,8 +59,6 @@
 #include <vm/vm_page.h>
 #include <sys/ptrace.h>
 
-#include <machine/vmm.h>
-
 static int	procfs_rwmem (struct proc *curp,
 				  struct proc *p, struct uio *uio);
 
@@ -121,17 +119,6 @@ procfs_rwmem(struct proc *curp, struct proc *p, struct uio *uio)
 		pageno = trunc_page(uva);
 		page_offset = uva - pageno;
 
-		/*
-		 * If the target process is running in VMM mode
-		 * translate the address into a GPA (Guest Physical
-		 * Address) via the EPT before doing the lookup.
-		 */
-		if (p->p_vmm) {
-			register_t gpa;
-			vmm_vm_get_gpa(p, &gpa, (register_t) pageno);
-			pageno = (vm_offset_t)gpa;
-		}
-
 		/*
 		 * How many bytes to copy
 		 */
diff --git a/sys/vm/vm_glue.c b/sys/vm/vm_glue.c
index 6f615edac56..d3112a89c06 100644
--- a/sys/vm/vm_glue.c
+++ b/sys/vm/vm_glue.c
@@ -73,7 +73,6 @@
 #include <sys/unistd.h>
 
 #include <machine/limits.h>
-#include <machine/vmm.h>
 
 #include <vm/vm.h>
 #include <vm/vm_param.h>
@@ -147,18 +146,11 @@ useracc(c_caddr_t addr, int len, int rw)
 	vm_prot_t prot;
 	vm_map_t map;
 	vm_offset_t wrap;
-	vm_offset_t gpa;
 
 	KASSERT((rw & (~VM_PROT_ALL)) == 0,
 	    ("illegal ``rw'' argument to useracc (%x)", rw));
 	prot = rw;
 
-	if (curthread->td_vmm) {
-		if (vmm_vm_get_gpa(curproc, (register_t *)&gpa, (register_t) addr))
-			panic("%s: could not get GPA\n", __func__);
-		addr = (c_caddr_t) gpa;
-	}
-
 	/*
 	 * XXX - check separately to disallow access to user area and user
 	 * page tables - they are in the map.
diff --git a/sys/vm/vm_vmspace.c b/sys/vm/vm_vmspace.c
index 87ef43920d8..4702fab8c0c 100644
--- a/sys/vm/vm_vmspace.c
+++ b/sys/vm/vm_vmspace.c
@@ -51,7 +51,6 @@
 #include <vm/pmap.h>
 
 #include <machine/vmparam.h>
-#include <machine/vmm.h>
 
 static struct vmspace_entry *vkernel_find_vmspace(struct vkernel_proc *vkp,
 						  void *id, int havetoken);
@@ -108,9 +107,6 @@ sys_vmspace_create(struct sysmsg *sysmsg,
 		lwkt_reltoken(&p->p_token);
 	}
 
-	if (curthread->td_vmm)
-		return 0;
-
 	/*
 	 * Create a new VMSPACE, disallow conflicting ids
 	 */
@@ -196,16 +192,12 @@ sys_vmspace_ctl(struct sysmsg *sysmsg,
 		return (EINVAL);
 
 	/*
-	 * ve only matters when VMM is not used.
-	 *
 	 * NOTE: We have to copy *uap into ua because uap is an aliased
 	 *	 pointer into the sysframe, which we are replacing.
 	 */
-	if (curthread->td_vmm == NULL) {
-		if ((ve = vkernel_find_vmspace(vkp, ua.id, 0)) == NULL) {
-			error = ENOENT;
-			goto done;
-		}
+	if ((ve = vkernel_find_vmspace(vkp, ua.id, 0)) == NULL) {
+		error = ENOENT;
+		goto done;
 	}
 
 	switch(ua.cmd) {
@@ -249,20 +241,9 @@ sys_vmspace_ctl(struct sysmsg *sysmsg,
 			      sizeof(vklp->save_vextframe.vx_tls));
 			set_user_TLS();
 		} else {
-			/*
-			 * If it's a VMM thread just set the CR3. We also set
-			 * the vklp->ve to a key to be able to distinguish
-			 * when a vkernel user process runs and when not
-			 * (when it's NULL)
-			 */
-			if (curthread->td_vmm == NULL) {
-				vklp->ve = ve;
-				atomic_add_int(&ve->refs, 1);
-				pmap_setlwpvm(lp, ve->vmspace);
-			} else {
-				vklp->ve = ua.id;
-				vmm_vm_set_guest_cr3((register_t)ua.id);
-			}
+			vklp->ve = ve;
+			atomic_add_int(&ve->refs, 1);
+			pmap_setlwpvm(lp, ve->vmspace);
 			set_user_TLS();
 			set_vkernel_fp(sysmsg->sysmsg_frame);
 			error = EJUSTRETURN;
@@ -776,23 +757,16 @@ vkernel_lwp_exit(struct lwp *lp)
 	struct vmspace_entry *ve;
 
 	if ((vklp = lp->lwp_vkernel) != NULL) {
-		if (lp->lwp_thread->td_vmm == NULL) {
-			/*
-			 * vkernel thread
-			 */
-			if ((ve = vklp->ve) != NULL) {
-				kprintf("Warning, pid %d killed with "
-					"active VC!\n", lp->lwp_proc->p_pid);
-				pmap_setlwpvm(lp, lp->lwp_proc->p_vmspace);
-				vklp->ve = NULL;
-				KKASSERT(ve->refs > 0);
-				vmspace_entry_drop(ve);
-			}
-		} else {
-			/*
-			 * guest thread
-			 */
+		/*
+		 * vkernel thread
+		 */
+		if ((ve = vklp->ve) != NULL) {
+			kprintf("Warning, pid %d killed with "
+			    "active VC!\n", lp->lwp_proc->p_pid);
+			pmap_setlwpvm(lp, lp->lwp_proc->p_vmspace);
 			vklp->ve = NULL;
+			KKASSERT(ve->refs > 0);
+			vmspace_entry_drop(ve);
 		}
 		if ((ve = vklp->ve_cache) != NULL) {
 			vklp->ve_cache = NULL;
@@ -824,23 +798,17 @@ vkernel_trap(struct lwp *lp, struct trapframe *frame)
 	vklp = lp->lwp_vkernel;
 	KKASSERT(vklp);
 
-	/* If it's a VMM thread just set the vkernel CR3 back */
-	if (curthread->td_vmm == NULL) {
-		ve = vklp->ve;
-		KKASSERT(ve != NULL);
+	ve = vklp->ve;
+	KKASSERT(ve != NULL);
 
-		/*
-		 * Switch the LWP vmspace back to the virtual kernel's VM space.
-		 */
-		vklp->ve = NULL;
-		pmap_setlwpvm(lp, p->p_vmspace);
-		KKASSERT(ve->refs > 0);
-		vmspace_entry_drop(ve);
-		/* ve is invalid once we kill our ref */
-	} else {
-		vklp->ve = NULL;
-		vmm_vm_set_guest_cr3(p->p_vkernel->vkernel_cr3);
-	}
+	/*
+	 * Switch the LWP vmspace back to the virtual kernel's VM space.
+	 */
+	vklp->ve = NULL;
+	pmap_setlwpvm(lp, p->p_vmspace);
+	KKASSERT(ve->refs > 0);
+	vmspace_entry_drop(ve);
+	/* ve is invalid once we kill our ref */
 
 	/*
 	 * Copy the emulated process frame to the virtual kernel process.
